
// [...]

// greylink dc++: work with long timestamps
int64_t File::getTimeStamp(const string& aFileName) throw(FileException) {
        WIN32_FIND_DATA fd;
        HANDLE hFind = FindFirstFile(Text::toT(aFileName).c_str(), &fd);
        if (hFind == INVALID_HANDLE_VALUE)
                throw FileException(Util::translateError(GetLastError()) + ": " + aFileName);
        FindClose(hFind);
        return *(int64_t*)&fd.ftLastWriteTime;
}
void File::setTimeStamp(const string& aFileName, const int64_t stamp) throw(FileException) {
        HANDLE h = CreateFile(Text::toT(aFileName).c_str(), FILE_WRITE_ATTRIBUTES, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
        if(h == INVALID_HANDLE_VALUE)
                throw FileException(Util::translateError(GetLastError()) + ": " + aFileName);
        if (!SetFileTime(h, NULL, NULL, (FILETIME*)&stamp))
                throw FileException(Util::translateError(GetLastError()) + ": " + aFileName);
        CloseHandle(h);
}

// [...]
